\documentclass[10pt]{beamer}
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}

% \usetheme{Copenhagen}
\usecolortheme{structure}
\beamertemplatenavigationsymbolsempty 

\title{String Algorithms}
\author{CS104C}
\institute{UT Austin}
\date{}

\begin{document}

\frame{\titlepage}

\begin{frame}
  \frametitle{String Algorithms}

  \textbf{String Algorithms:} Algorithms which deal with processing strings
  \textit{efficiently}. \pause

  \\~\\

  For example, \textbf{pattern matching}: given a string of length $n$ and a
  string of length $m$, find all occurrences of the pattern in the string. \pause

  \\~\\

  Can be done naively in: \pause $O(nm)$ using brute force. \pause

  Can be done efficiently in: $O(n + m)$ time.

\end{frame}

\begin{frame}
  \frametitle{Terminology}

  \begin{itemize}
    \item \textbf{Substring}: \pause a sequence of consecutive characters within a
      string.
      For example the substrings of $\texttt{ABC}$ are $\texttt{A},
      \texttt{B}, \texttt{C}, \texttt{AB}, \texttt{BC}, \texttt{ABC}$. \pause

    \item \textbf{Subsequence}: \pause a sequence of characters which can be obtained by deleting any number
      of characters from the original string. For example the subsequences of
      $\texttt{ABC}$ are $\texttt{A},
      \texttt{B}, \texttt{C}, \texttt{AB}, \texttt{BC}, \texttt{ABC},
      \texttt{AC}$. \pause

    \item \textbf{Prefix}: \pause a substring that starts at the beginning of the
      string. \pause
    \item \textbf{Suffix}: \pause a substring that ends at the end of the
      string. \pause

    \item \textbf{Lexicographical order}: \pause we will generally compare strings such
      that for two strings $s, t$, $s < t$ if there is a position $i$ where
      $s[i] < t[i]$ and for all $j < i$, $s[j] = t[j]$. If no such position
      exists, then $s < t$ only if $s$ is a proper prefix of $t$. \pause
  \end{itemize}

\end{frame}

\begin{frame}
  \frametitle{Other Examples}

  \textbf{Palindrome finding}: given a string of length $n$, find the longest
  palindromic substring of the string. Can also ask, find the number of
  palindromic substrings.

\end{frame}

\begin{frame}
  \frametitle{Terminology}

  
\end{frame}

\end{document}
